<!--//
////////////////////////////////////////////////////////////////////////////////
//
//  Copyright  2007 addgadget.com  All rights reserved.
//
//  http://addgadget.com/
//
////////////////////////////////////////////////////////////////////////////////
//-->
System.Gadget.onSettingsClosing = SettingsClosing;
var Speedfan;
var valueCount=5;

function onLoad()
{
    debugLog("### LOAD SETTINGS ###");
    debugLog("GetLibrary (Settings)");
    Speedfan = GetLibrary();
    initSettings();
}

function onUnload()
{
   debugLog("### UNLOAD SETTINGS ###");
}

function SettingsClosing(event)
{

	if (event.closeAction == event.Action.commit) 
		saveSettings();
	event.cancel = false;
}

function initSettings()
{
    updateCombos();
    loadSettings();
}

function loadSettings()
{

    debugLog("loadSettings");
    for (var s = 0;s < valueCount; s++)
    {
        debugLog("loadSettings:tmp"+s+" ->"+ System.Gadget.Settings.read("tmp"+s+"index"));
        document.getElementById("tmp"+s).value = System.Gadget.Settings.read("tmp"+s+"index");
    }

    DrawStyle.value = System.Gadget.Settings.read("drawstyle");
    background.value = System.Gadget.Settings.read("background");
    loadGlobalBackgroundSettings("background","globalback");
}

function saveSettings()
{
    debugLog("saveSettings");
    for (var s = 0;s < valueCount; s++)
    {
        debugLog("saveSettings:tmp"+s+"index ->"+ document.getElementById("tmp"+s).value);
        System.Gadget.Settings.write("tmp"+s+"index", document.getElementById("tmp"+s).value);
    }
    System.Gadget.Settings.write("drawstyle", DrawStyle.value);
    System.Gadget.Settings.write("background", background.value);
    
    saveGlobalBackgroundSettings("background","globalback");
}

function updateCombos()
{
    debugLog("updateCombos");
    try 
    {
        Speedfan.Refresh();
        for (var s = 0;s < valueCount; s++)
        {
            for (var t = 0;t < Speedfan.GetTemperatureCount();t++)
            {
                document.getElementById("tmp"+s).options.add( new Option("Temp"+t+": " + Speedfan.GetTemperature(t) +  "C",t) );
            }
        }
    }
	catch(err) 
	{
	    debugLog("updateCombos: "+err.name+" - "+err.message)
	}
}